/**
 * XMPP Component connection
 *
 * change EXAMPLE.COM to match your domain
 * jid referrs to your component address. Not a user JID
 */

exports.xmpp = { jid: 'buddycloud.EXAMPLE.COM',
		 password: 'tellnoone',
		 host: 'localhost',
		 port: 5347
	       };

/**
 * PostgreSQL backend
 */
exports.modelBackend = 'postgres';
exports.modelConfig = {
    host: 'localhost',
    port: 5432,
    database: 'buddycloud-server',
    user: 'buddycloud-server',
    password: 'tellnoone',
    poolSize: 4
};

/**
 * Logging
 */
exports.logging = {
    colorized: true,
    /**
     * one of "FATAL", "ERROR", "WARN", "INFO", "DEBUG", "TRACE"
     */
    level: "INFO",
    /* stdout: true, */
    syslog: {
	/* hostname: "localhost", port: 514 */
    },
    file: "/var/log/buddycloud-server.log"
};

/**
 * Who may create what node?
 *
 * Default: only allow creating a personal channel, or a topic channel
 * on a specific domain.
 */
exports.checkCreateNode = function(opts) {
    return (opts.nodeUser === opts.actor) ||
	(opts.nodeUser.split("@")[1] === "topics.buddycloud.org");
};

/**
 * Welcome new users by auto-subscribing them to a few channels
 */
exports.autosubscribeNewUsers = [
    "lounge@topics.buddycloud.org",
    "topics@topics.buddycloud.org"
];
