// Generated by CoffeeScript 1.3.3
(function() {
  var NS_XMPP_STANZAS, ServerError, inherits, xmpp,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  try {
    inherits = require("util").inherits;
  } catch (x) {
    try {
      inherits = require("utils").inherits;
    } catch (x) {
      inherits = require("sys").inherits;
    }
  }

  xmpp = require("node-xmpp");

  NS_XMPP_STANZAS = "urn:ietf:params:xml:ns:xmpp-stanzas";

  ServerError = (function(_super) {

    __extends(ServerError, _super);

    function ServerError(message) {
      this.message = message;
    }

    ServerError.prototype.condition = 'undefined-condition';

    ServerError.prototype.type = 'cancel';

    ServerError.prototype.xmppElement = function() {
      var errorEl;
      errorEl = new xmpp.Element("error", {
        type: this.type
      });
      errorEl.c(this.condition, {
        xmlns: NS_XMPP_STANZAS
      });
      if (this.message) {
        errorEl.c("text", {
          xmlns: NS_XMPP_STANZAS
        }).t(this.message);
      }
      return errorEl;
    };

    return ServerError;

  })(Error);

  exports.Forbidden = (function(_super) {

    __extends(Forbidden, _super);

    function Forbidden() {
      return Forbidden.__super__.constructor.apply(this, arguments);
    }

    Forbidden.prototype.condition = "forbidden";

    Forbidden.prototype.type = "auth";

    return Forbidden;

  })(ServerError);

  exports.Conflict = (function(_super) {

    __extends(Conflict, _super);

    function Conflict() {
      return Conflict.__super__.constructor.apply(this, arguments);
    }

    Conflict.prototype.condition = "conflict";

    Conflict.prototype.type = "cancel";

    return Conflict;

  })(ServerError);

  exports.BadRequest = (function(_super) {

    __extends(BadRequest, _super);

    function BadRequest() {
      return BadRequest.__super__.constructor.apply(this, arguments);
    }

    BadRequest.prototype.condition = "bad-request";

    BadRequest.prototype.type = "modify";

    return BadRequest;

  })(ServerError);

  exports.FeatureNotImplemented = (function(_super) {

    __extends(FeatureNotImplemented, _super);

    function FeatureNotImplemented() {
      return FeatureNotImplemented.__super__.constructor.apply(this, arguments);
    }

    FeatureNotImplemented.prototype.condition = "feature-not-implemented";

    FeatureNotImplemented.prototype.type = "cancel";

    return FeatureNotImplemented;

  })(ServerError);

  exports.InternalServerError = (function(_super) {

    __extends(InternalServerError, _super);

    function InternalServerError() {
      return InternalServerError.__super__.constructor.apply(this, arguments);
    }

    InternalServerError.prototype.condition = "internal-server-error";

    InternalServerError.prototype.type = "cancel";

    return InternalServerError;

  })(ServerError);

  exports.NotFound = (function(_super) {

    __extends(NotFound, _super);

    function NotFound() {
      return NotFound.__super__.constructor.apply(this, arguments);
    }

    NotFound.prototype.condition = "item-not-found";

    NotFound.prototype.type = "cancel";

    return NotFound;

  })(ServerError);

  exports.NotAllowed = (function(_super) {

    __extends(NotAllowed, _super);

    function NotAllowed() {
      return NotAllowed.__super__.constructor.apply(this, arguments);
    }

    NotAllowed.prototype.condition = "not-allowed";

    NotAllowed.prototype.type = "cancel";

    return NotAllowed;

  })(ServerError);

  exports.StanzaError = (function(_super) {

    __extends(StanzaError, _super);

    function StanzaError(stanza) {
      var _ref, _ref1;
      this.el = stanza.getChild('error');
      this.message = (_ref = this.el) != null ? (_ref1 = _ref.children[0]) != null ? _ref1.name : void 0 : void 0;
    }

    StanzaError.prototype.xmppElement = function() {
      return this.el;
    };

    return StanzaError;

  })(Error);

  exports.SeeLocal = (function(_super) {

    __extends(SeeLocal, _super);

    function SeeLocal() {
      SeeLocal.__super__.constructor.call(this, "Locally stored");
    }

    return SeeLocal;

  })(Error);

  exports.MaxStanzaSizeExceeded = (function(_super) {

    __extends(MaxStanzaSizeExceeded, _super);

    function MaxStanzaSizeExceeded(bytes) {
      MaxStanzaSizeExceeded.__super__.constructor.call(this, "Maximum stanza size exceeded (" + bytes + " bytes)");
    }

    return MaxStanzaSizeExceeded;

  })(Error);

}).call(this);
