// Generated by CoffeeScript 1.3.3
(function() {
  var AuthorizationPromptNotification, EventNotification, NS, Notification, forms, xmpp,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  xmpp = require('node-xmpp');

  NS = require('./ns');

  forms = require('./forms');

  Notification = (function() {

    function Notification(opts) {
      this.opts = opts;
    }

    Notification.prototype.toStanza = function(fromJid, toJid) {
      var message;
      message = new xmpp.Element('message', {
        type: 'headline',
        from: fromJid,
        to: toJid
      });
      if (this.opts.replay) {
        return message.c('forwarded', {
          xmlns: NS.FORWARD
        }).c('message', {
          type: 'headline',
          from: fromJid,
          to: toJid
        });
      } else {
        return message;
      }
    };

    return Notification;

  })();

  EventNotification = (function(_super) {

    __extends(EventNotification, _super);

    function EventNotification() {
      return EventNotification.__super__.constructor.apply(this, arguments);
    }

    EventNotification.prototype.toStanza = function(fromJid, toJid) {
      var eventEl, item, itemsEl, update, _i, _j, _len, _len1, _ref, _ref1;
      eventEl = EventNotification.__super__.toStanza.apply(this, arguments).c('event', {
        xmlns: NS.PUBSUB_EVENT
      });
      _ref = this.opts;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        update = _ref[_i];
        switch (update.type) {
          case 'items':
            itemsEl = eventEl.c('items', {
              node: update.node
            });
            _ref1 = update.items;
            for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
              item = _ref1[_j];
              itemsEl.c('item', {
                id: item.id
              }).cnode(item.el);
            }
            break;
          case 'subscription':
            eventEl.c('subscription', {
              jid: update.user,
              node: update.node,
              subscription: update.subscription
            });
            break;
          case 'affiliation':
            eventEl.c('affiliation', {
              jid: update.user,
              node: update.node,
              affiliation: update.affiliation
            });
            break;
          case 'config':
            eventEl.c('configuration', {
              node: update.node
            }).cnode(forms.configToForm(update.config, 'result', NS.PUBSUB_NODE_CONFIG).toXml());
        }
      }
      return eventEl;
    };

    return EventNotification;

  })(Notification);

  AuthorizationPromptNotification = (function(_super) {

    __extends(AuthorizationPromptNotification, _super);

    function AuthorizationPromptNotification() {
      return AuthorizationPromptNotification.__super__.constructor.apply(this, arguments);
    }

    AuthorizationPromptNotification.prototype.toStanza = function(fromJid, toJid) {
      var form;
      form = new forms.Form('form', NS.PUBSUB_SUBSCRIBE_AUTHORIZATION);
      form.title = 'Confirm channel subscription';
      form.instructions = "Allow " + this.opts.user + " to subscribe to node " + this.opts.node + "?";
      form.addField('pubsub#node', 'text-single', 'Node', this.opts.node);
      form.addField('pubsub#subscriber_jid', 'jid-single', 'Subscriber Address', this.opts.user);
      form.addField('pubsub#allow', 'boolean', 'Allow?', 'false');
      return AuthorizationPromptNotification.__super__.toStanza.apply(this, arguments).cnode(form.toXml());
    };

    return AuthorizationPromptNotification;

  })(Notification);

  exports.make = function(opts) {
    switch (opts.type) {
      case 'authorizationPrompt':
        return new AuthorizationPromptNotification(opts);
      default:
        return new EventNotification(opts);
    }
  };

}).call(this);
